package Forms;

import DrawningObjects.CountEnum;
import DrawningObjects.DrawningElectricLocomotive;
import MovementStrategy.*;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Random;

public  class FormElectricLocomotive extends JFrame {
    private DrawningElectricLocomotive _drawningElectricLocomotive;
    private Canvas canvas;
    private JButton buttonCreate;
    private JButton buttonUp;
    private JButton buttonRight;
    private JButton buttonDown;
    private JButton buttonLeft;
    private JTextField numberField;
    public void Draw() {
        if (_drawningElectricLocomotive == null)
        {
            return;
        }
        _drawningElectricLocomotive.DrawTransport(canvas.getGraphics());
    }
    private void InitializeComponent(){
        buttonCreate = new JButton("Создать");

        buttonUp = new JButton();
        buttonUp.setBorderPainted(false);
        buttonUp.setFocusPainted(false);
        buttonUp.setContentAreaFilled(false);
        buttonUp.setName("up");
        buttonUp.setIcon(new ImageIcon("Resources/arrowUp.png"));
        buttonUp.setSize(40, 40);

        buttonRight = new JButton();
        buttonRight.setBorderPainted(false);
        buttonRight.setFocusPainted(false);
        buttonRight.setContentAreaFilled(false);
        buttonRight.setName("right");
        buttonRight.setIcon(new ImageIcon("Resources/arrowRight.png"));
        buttonRight.setSize(40, 40);

        buttonDown = new JButton();
        buttonDown.setBorderPainted(false);
        buttonDown.setFocusPainted(false);
        buttonDown.setContentAreaFilled(false);
        buttonDown.setName("down");
        buttonDown.setIcon(new ImageIcon("Resources/arrowDown.png"));
        buttonDown.setSize(40, 40);

        buttonLeft = new JButton();
        buttonLeft.setBorderPainted(false);
        buttonLeft.setFocusPainted(false);
        buttonLeft.setContentAreaFilled(false);
        buttonLeft.setName("left");
        buttonLeft.setIcon(new ImageIcon("Resources/arrowLeft.png"));
        buttonLeft.setSize(40, 40);

        numberField = new JTextField();

        setSize(1000, 600);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setLayout(null);

        canvas = new Canvas();
        canvas.setBounds(0, 0, 1000, 600);
        buttonCreate.setBounds(10, 520, 120, 40);
        buttonUp.setBounds(50, 430, 40, 40);
        buttonDown.setBounds(50, 470, 40, 40);
        buttonRight.setBounds(90, 470, 40, 40);
        buttonLeft.setBounds(10, 470, 40, 40);
        numberField.setBounds(150, 520, 40, 40);


        add(buttonCreate);
        add(buttonUp);
        add(buttonDown);
        add(buttonRight);
        add(buttonLeft);
        add(numberField);
        add(canvas);
    }
    private void InitializeLogic(){
        buttonCreate.addActionListener(
                new ActionListener() {
                    public void actionPerformed(ActionEvent e){
                        int countWheels;
                        try {
                            countWheels = Integer.parseInt(numberField.getText());
                        }
                        catch (Exception ex){
                            countWheels = 0;
                        }
                        System.out.println(e.getActionCommand());
                        Random random = new Random();
                        _drawningElectricLocomotive = new DrawningElectricLocomotive();
                        _drawningElectricLocomotive.Init(random.nextInt(100, 300), random.nextInt(1000, 3000),
                                new Color(random.nextInt(0, 256), random.nextInt(0, 256), random.nextInt(0, 256)),
                                new Color(random.nextInt(0, 256), random.nextInt(0, 256), random.nextInt(0, 256)),
                                countWheels,
                                random.nextInt(0, 2) == 1, random.nextInt(0, 2) == 1,
                                1000, 560);
                        _drawningElectricLocomotive.SetPosition(random.nextInt(10, 100), random.nextInt(10, 100));
                        Draw();
                    }
                }
        );

        ActionListener actionListener = new ActionListener() {
            public void actionPerformed(ActionEvent e){
                System.out.println(((JButton)(e.getSource())).getName());
                if (_drawningElectricLocomotive == null)
                {
                    return;
                }
                switch(((JButton)(e.getSource())).getName()){
                    case "up":
                        _drawningElectricLocomotive.MoveTransport(DirectionType.Up);
                        break;
                    case "down":
                        _drawningElectricLocomotive.MoveTransport(DirectionType.Down);
                        break;
                    case "left":
                        _drawningElectricLocomotive.MoveTransport(DirectionType.Left);
                        break;
                    case "right":
                        _drawningElectricLocomotive.MoveTransport(DirectionType.Right);
                        break;
                }
                Draw();
            }
        };

        buttonUp.addActionListener(actionListener);
        buttonDown.addActionListener(actionListener);
        buttonLeft.addActionListener(actionListener);
        buttonRight.addActionListener(actionListener);

    }
    public FormElectricLocomotive(){
        InitializeComponent();
        InitializeLogic();
        setVisible(true);
    }
}
